Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.openjpa.lib.util.concurrent
Class ConcurrentLinkedQueue

    java.lang.Object
      java.util.AbstractCollection
          org.apache.openjpa.lib.util.concurrent.ConcurrentLinkedQueue

All Implemented Interfaces:
  Serializable, Iterable, Collection, Queue

    public class ConcurrentLinkedQueue

extends AbstractCollection
implements Queue, Serializable

An unbounded thread-safe queue based on linked nodes. This queue orders elements FIFO(first-in-first-out). The head of the queue is that element that has been on the queue the longest time. The tail of the queue is that element that has been on the queue the shortest time. New elements are inserted at the tail of the queue, and the queue retrieval operations obtain elements at the head of the queue. A `ConcurrentLinkedQueue` is an appropriate choice when many threads will share access to a common collection. This queue does not permit `null` elements. This implementation employs an efficient "wait-free" algorithm based on one described in Simple, Fast, and Practical Non-Blocking and Blocking Concurrent Queue Algorithms by Maged M. Michael and Michael L. Scott. Beware that, unlike in most collections, the `size` method is NOT a constant-time operation. Because of the asynchronous nature of these queues, determining the current number of elements requires a traversal of the elements. This class and its iterator implement all of the optional methods of the `Collection` and `Iterator` interfaces. Memory consistency effects: As with other concurrent collections, actions in a thread prior to placing an object into a `ConcurrentLinkedQueue` happen-before actions subsequent to the access or removal of that element from the `ConcurrentLinkedQueue` in another thread. This class is a member of the Java Collections Framework.

Since:
  1.5
Author:
  Doug Lea
See Also:
  Serialized Form

Constructor Summary
`ConcurrentLinkedQueue()`
`ConcurrentLinkedQueue(Collection c)` Creates a `ConcurrentLinkedQueue` initially containing the elements of the given collection, added in traversal order of the collection's iterator.

Method Summary
`boolean` | `add(Object e)` Inserts the specified element at the tail of this queue.
`boolean` | `addAll(Collection c)` Adds all of the elements in the specified collection to this queue.
`void` | `clear()` Removes all of the elements from this queue.
`boolean` | `contains(Object o)` Returns `true` if this queue contains the specified element.
`Object` | `element()` Retrieves, but does not remove, the head of this queue.
`boolean` | `isEmpty()` Returns `true` if this queue contains no elements.
`Iterator` | `iterator()` Returns an iterator over the elements in this queue in proper sequence.
`boolean` | `offer(Object e)` Inserts the specified element at the tail of this queue.
`Object` | `peek()` Retrieves, but does not remove, the head of this queue, or returns `null` if this queue is empty.
`Object` | `poll()` Retrieves and removes the head of this queue, or returns `null` if this queue is empty.
`Object` | `remove()` Retrieves and removes the head of this queue.
`boolean` | `remove(Object o)` Removes a single instance of the specified element from this queue, if it is present.
`int` | `size()` Returns the number of elements in this queue.
`Object[]` | `toArray()`
`Object[]` | `toArray(Object[] a)`

Methods inherited from class java.util.AbstractCollection
`containsAll, removeAll, retainAll, toString`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface org.apache.openjpa.lib.util.concurrent.Queue
`element, remove`

Methods inherited from interface java.util.Collection
`addAll, clear, containsAll, equals, hashCode, removeAll, retainAll, toArray, toArray`

Constructor Detail

### ConcurrentLinkedQueue

    public ConcurrentLinkedQueue()

### ConcurrentLinkedQueue

    public ConcurrentLinkedQueue(Collection c)

  Creates a `ConcurrentLinkedQueue` initially containing the elements of the given collection, added in traversal order of the collection's iterator.

  Parameters:
    `c` - the collection of elements to initially contain
  Throws:
    `NullPointerException` - if the specified collection or any of its elements are null

Method Detail

### add

    public boolean add(Object e)

  Inserts the specified element at the tail of this queue.

  Specified by:
    `add` in interface `Collection`
  Specified by:
    `add` in interface `Queue`
  Parameters:
    `e` - the element to add
  Returns:
    `true` (as specified by `Collection.add(E)`)
  Throws:
    `NullPointerException` - if the specified element is null

### offer

    public boolean offer(Object e)

  Inserts the specified element at the tail of this queue.

  Specified by:
    `offer` in interface `Queue`
  Parameters:
    `e` - the element to add
  Returns:
    `true` (as specified by `Queue.offer(java.lang.Object)`)
  Throws:
    `NullPointerException` - if the specified element is null

### poll

    public Object poll()

  Description copied from interface: `Queue`
  Retrieves and removes the head of this queue, or returns `null` if this queue is empty.

  Specified by:
    `poll` in interface `Queue`
  Returns:
    the head of this queue, or `null` if this queue is empty

### peek

    public Object peek()

  Description copied from interface: `Queue`
  Retrieves, but does not remove, the head of this queue, or returns `null` if this queue is empty.

  Specified by:
    `peek` in interface `Queue`
  Returns:
    the head of this queue, or `null` if this queue is empty

### isEmpty

    public boolean isEmpty()

  Returns `true` if this queue contains no elements.

  Specified by:
    `isEmpty` in interface `Collection`
  Overrides:
    `isEmpty` in class `AbstractCollection`
  Returns:
    `true` if this queue contains no elements

### size

    public int size()

  Returns the number of elements in this queue. If this queue contains more than `Integer.MAX_VALUE` elements, returns `Integer.MAX_VALUE`. Beware that, unlike in most collections, this method is NOT a constant-time operation. Because of the asynchronous nature of these queues, determining the current number of elements requires an O(n) traversal.

  Specified by:
    `size` in interface `Collection`
  Specified by:
    `size` in class `AbstractCollection`
  Returns:
    the number of elements in this queue

### contains

    public boolean contains(Object o)

  Returns `true` if this queue contains the specified element. More formally, returns `true` if and only if this queue contains at least one element `e` such that `o.equals(e)`.

  Specified by:
    `contains` in interface `Collection`
  Overrides:
    `contains` in class `AbstractCollection`
  Parameters:
    `o` - object to be checked for containment in this queue
  Returns:
    `true` if this queue contains the specified element

### remove

    public boolean remove(Object o)

  Removes a single instance of the specified element from this queue, if it is present. More formally, removes an element `e` such that `o.equals(e)`, if this queue contains one or more such elements. Returns `true` if this queue contained the specified element (or equivalently, if this queue changed as a result of the call).

  Specified by:
    `remove` in interface `Collection`
  Overrides:
    `remove` in class `AbstractCollection`
  Parameters:
    `o` - element to be removed from this queue, if present
  Returns:
    `true` if this queue changed as a result of the call

### iterator

    public Iterator iterator()

  Returns an iterator over the elements in this queue in proper sequence. The returned iterator is a "weakly consistent" iterator that will never throw `ConcurrentModificationException`, and guarantees to traverse elements as they existed upon construction of the iterator, and may(but is not guaranteed to) reflect any modifications subsequent to construction.

  Specified by:
    `iterator` in interface `Iterable`
  Specified by:
    `iterator` in interface `Collection`
  Specified by:
    `iterator` in class `AbstractCollection`
  Returns:
    an iterator over the elements in this queue in proper sequence

### remove

    public Object remove()

  Retrieves and removes the head of this queue. This method differs from `poll` only in that it throws an exception if this queue is empty. This implementation returns the result of `poll` unless the queue is empty.

  Specified by:
    `remove` in interface `Queue`
  Returns:
    the head of this queue
  Throws:
    `NoSuchElementException` - if this queue is empty

### element

    public Object element()

  Retrieves, but does not remove, the head of this queue. This method differs from `peek` only in that it throws an exception if this queue is empty. This implementation returns the result of `peek` unless the queue is empty.

  Specified by:
    `element` in interface `Queue`
  Returns:
    the head of this queue
  Throws:
    `NoSuchElementException` - if this queue is empty

### clear

    public void clear()

  Removes all of the elements from this queue. The queue will be empty after this call returns. This implementation repeatedly invokes `poll` until it returns `null`.

  Specified by:
    `clear` in interface `Collection`
  Overrides:
    `clear` in class `AbstractCollection`

### addAll

    public boolean addAll(Collection c)

  Adds all of the elements in the specified collection to this queue. Attempts to addAll of a queue to itself result in `IllegalArgumentException`. Further, the behavior of this operation is undefined if the specified collection is modified while the operation is in progress. This implementation iterates over the specified collection, and adds each element returned by the iterator to this queue, in turn. A runtime exception encountered while trying to add an element(including, in particular, a `null` element) may result in only some of the elements having been successfully added when the associated exception is thrown.

  Specified by:
    `addAll` in interface `Collection`
  Overrides:
    `addAll` in class `AbstractCollection`
  Parameters:
    `c` - collection containing elements to be added to this queue
  Returns:
    `true` if this queue changed as a result of the call
  Throws:
    `ClassCastException` - if the class of an element of the specified collection prevents it from being added to this queue
    `NullPointerException` - if the specified collection contains a null element and this queue does not permit null elements, or if the specified collection is null
    `IllegalArgumentException` - if some property of an element of the specified collection prevents it from being added to this queue, or if the specified collection is this queue
    `IllegalStateException` - if not all the elements can be added at this time due to insertion restrictions
  See Also:
    `add(Object)`

### toArray

    public Object[] toArray()

  Specified by:
    `toArray` in interface `Collection`
  Overrides:
    `toArray` in class `AbstractCollection`

### toArray

    public Object[] toArray(Object[] a)

  Specified by:
    `toArray` in interface `Collection`
  Overrides:
    `toArray` in class `AbstractCollection`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2006 Apache Software Foundation. All Rights Reserved.